/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package tdd_with_fitnesse;

import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.StringTokenizer;
import java.util.regex.Pattern;

/**
 *
 * @author Selvyn
 */
public class TimeFormatter
{
    final   static  private TimeFormatter self = new TimeFormatter();
    private final NumberFormat itsNumberFormatter = NumberFormat.getIntegerInstance();
    private String  tokens[];
    
    public TimeFormatter()
    {
        itsNumberFormatter.setMinimumIntegerDigits(2);
    }
    static  public  TimeFormatter   getInstance()
    {
        return self;
    }
    
    public  String  format( String input ) throws BadlyFormedTime
    {
        if( input.length() < 4 )
            throw new BadlyFormedTime("Time length too short");
        //if( input.length() > 7 )
        //    throw new BadlyFormedTime("Time length too long");
        
        tokeniseWithSplit(input, ":|\\s");
        
        if( tokens[0].equals("ERR"))
            throw new BadlyFormedTime("Badly formed time");
        
        int hours = new Integer( tokens[0] );
        int mins = new Integer( tokens[1]);
        
        if( tokens.length > 2 )
        {
            if(tokens[2].equals("PM") )
            {
                if( hours < 12 )
                {
                    hours += 12;
                    tokens[0] = itsNumberFormatter.format( hours );
                }
            }
            if( tokens[2].equals("AM") )
            {
                if( hours == 12 )
                {
                    tokens[0] = "00";
                }
                else
                    tokens[0] = itsNumberFormatter.format( hours );
            }
        }
        else
        {
            tokens[0] = itsNumberFormatter.format( hours );
            tokens[1] = itsNumberFormatter.format( mins );
            
        }
        return tokens[0]+":"+tokens[1];
    }
    
    public  String[]    getTokens()
    {
        return tokens;
    }
    
    public String[] tokenise( String input, String delims )
    {
        System.out.println("StringTokenizer Example: \n");
        input = input.toUpperCase();
        StringTokenizer st = new StringTokenizer(input, delims);
        ArrayList<String> stringArray = new ArrayList<String>();
        while (st.hasMoreElements()) 
        {
            String item = (String)st.nextElement();
            stringArray.add(item);
            System.out.println("StringTokenizer Output: " + item );
        }
        tokens = new String[stringArray.size()];
        tokens = stringArray.toArray(tokens);
        
        return tokens;
    }

    public String[] tokeniseWithSplit( String input, String regex )
    {
        System.out.println("StringTokenizer with Split Example: \n");
        input = makeCanonicalTimeFormat(input);

        System.out.println("\n\nSplit Example: \n");
        
        Pattern pp = Pattern.compile( regex );
        tokens = pp.split(input);

        if( tokens.length > 2 && tokens[2].equals("AM") )
        {
            int hours = Integer.parseInt(tokens[0]);
            if(hours > 12)
            {
                tokens[0] = "ERR";
                tokens[1] = "ERR";
                tokens[2] = "ERR";
            }
        }
            
        int tokenCount = tokens.length;
        for (int j = 0; j < tokenCount; j++) 
        {
                System.out.println("Split Output: "+ tokens[j]);
        }
        
        return tokens;
    }
    
    public  String  makeCanonicalTimeFormat( String input )
    {
        input = input.toUpperCase();
        String result = input;
        String timeOfDay = "";
        int idx = 0;
    
        if( input.contains("AM") )
        {
            idx = input.indexOf("AM");
            timeOfDay = "AM";
        }
        else if( input.contains("PM") )
        {
            idx = input.indexOf("PM");
            timeOfDay = "PM";
        }
        
        if( idx > 0 && input.charAt(idx-1) != ' ')
        {
            result = input.substring(0, idx);
            result += " " + timeOfDay;
        }
        return result;
    }
}
